/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSClusterTemplateLister helps list AWSClusterTemplates.
// All objects returned here must be treated as read-only.
type AWSClusterTemplateLister interface {
	// List lists all AWSClusterTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSClusterTemplate, err error)
	// AWSClusterTemplates returns an object that can list and get AWSClusterTemplates.
	AWSClusterTemplates(namespace string) AWSClusterTemplateNamespaceLister
	AWSClusterTemplateListerExpansion
}

// aWSClusterTemplateLister implements the AWSClusterTemplateLister interface.
type aWSClusterTemplateLister struct {
	indexer cache.Indexer
}

// NewAWSClusterTemplateLister returns a new AWSClusterTemplateLister.
func NewAWSClusterTemplateLister(indexer cache.Indexer) AWSClusterTemplateLister {
	return &aWSClusterTemplateLister{indexer: indexer}
}

// List lists all AWSClusterTemplates in the indexer.
func (s *aWSClusterTemplateLister) List(selector labels.Selector) (ret []*v1beta2.AWSClusterTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSClusterTemplate))
	})
	return ret, err
}

// AWSClusterTemplates returns an object that can list and get AWSClusterTemplates.
func (s *aWSClusterTemplateLister) AWSClusterTemplates(namespace string) AWSClusterTemplateNamespaceLister {
	return aWSClusterTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSClusterTemplateNamespaceLister helps list and get AWSClusterTemplates.
// All objects returned here must be treated as read-only.
type AWSClusterTemplateNamespaceLister interface {
	// List lists all AWSClusterTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSClusterTemplate, err error)
	// Get retrieves the AWSClusterTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSClusterTemplate, error)
	AWSClusterTemplateNamespaceListerExpansion
}

// aWSClusterTemplateNamespaceLister implements the AWSClusterTemplateNamespaceLister
// interface.
type aWSClusterTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSClusterTemplates in the indexer for a given namespace.
func (s aWSClusterTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSClusterTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSClusterTemplate))
	})
	return ret, err
}

// Get retrieves the AWSClusterTemplate from the indexer for a given namespace and name.
func (s aWSClusterTemplateNamespaceLister) Get(name string) (*v1beta2.AWSClusterTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsclustertemplate"), name)
	}
	return obj.(*v1beta2.AWSClusterTemplate), nil
}
